package com.fabianfdz.UI;

import com.fabianfdz.BusinessLogic.BusinessLogic;
import java.awt.event.ItemEvent;
import javax.swing.DefaultComboBoxModel;
import javax.swing.DefaultListModel;
import javax.swing.JOptionPane;

/**
 *
 * @author fabianfdz
 */
public class AgregarResultados extends javax.swing.JFrame {

    /**
     * Creates new form AgregarResultados
     */
    public AgregarResultados() {
        initComponents();
        this.drpdwnMedico.setVisible(false);
        this.inpValorado.setVisible(false);
        this.inpIndicaciones.setVisible(false);
        this.lblIndicaciones.setVisible(false);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroupResultado = new javax.swing.ButtonGroup();
        buttonGroupValorador = new javax.swing.ButtonGroup();
        lblTitle = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        radioPositivo = new javax.swing.JRadioButton();
        radioNegativo = new javax.swing.JRadioButton();
        inpBuscarPaciente = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        listPacientes = new javax.swing.JList<>();
        jScrollPane2 = new javax.swing.JScrollPane();
        inpIndicaciones = new javax.swing.JTextArea();
        lblIndicaciones = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        jLabel4 = new javax.swing.JLabel();
        radioMedico = new javax.swing.JRadioButton();
        radioMedico1 = new javax.swing.JRadioButton();
        drpdwnMedico = new javax.swing.JComboBox<>();
        inpValorado = new javax.swing.JTextField();
        btnAtra = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        lblTitle.setFont(new java.awt.Font("Dialog", 1, 14)); // NOI18N
        lblTitle.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblTitle.setText("Agregar Resultado");

        jLabel1.setText("Buscar paciente");

        jLabel2.setText("Resultado:");

        buttonGroupResultado.add(radioPositivo);
        radioPositivo.setText("Positivo");
        radioPositivo.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                radioPositivoStateChanged(evt);
            }
        });
        radioPositivo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                radioPositivoActionPerformed(evt);
            }
        });

        buttonGroupResultado.add(radioNegativo);
        radioNegativo.setText("Negativo");
        radioNegativo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                radioNegativoActionPerformed(evt);
            }
        });

        inpBuscarPaciente.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                inpBuscarPacienteKeyTyped(evt);
            }
        });

        listPacientes.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jScrollPane1.setViewportView(listPacientes);

        inpIndicaciones.setColumns(20);
        inpIndicaciones.setLineWrap(true);
        inpIndicaciones.setRows(5);
        inpIndicaciones.setWrapStyleWord(true);
        jScrollPane2.setViewportView(inpIndicaciones);

        lblIndicaciones.setText("Indicaciones");

        jButton1.setText("Agregar");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jLabel4.setText("Registro realizado por:");

        buttonGroupValorador.add(radioMedico);
        radioMedico.setText("Médico");
        radioMedico.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                radioMedicoActionPerformed(evt);
            }
        });

        buttonGroupValorador.add(radioMedico1);
        radioMedico1.setText("Otro");
        radioMedico1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                radioMedico1ActionPerformed(evt);
            }
        });

        drpdwnMedico.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        btnAtra.setText("Atrás");
        btnAtra.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAtraActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lblTitle, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel2)
                            .addComponent(lblIndicaciones))
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(radioPositivo)
                                .addGap(18, 18, 18)
                                .addComponent(radioNegativo)
                                .addGap(0, 0, Short.MAX_VALUE))
                            .addComponent(jScrollPane2)))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(btnAtra)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jButton1))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel4)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(radioMedico)
                            .addComponent(radioMedico1))
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(drpdwnMedico, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(inpValorado)))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel1)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(inpBuscarPaciente, javax.swing.GroupLayout.PREFERRED_SIZE, 158, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 407, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(lblTitle)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(inpBuscarPaciente, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(radioPositivo)
                    .addComponent(radioNegativo)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lblIndicaciones))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(radioMedico)
                    .addComponent(drpdwnMedico, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(radioMedico1)
                    .addComponent(inpValorado, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 23, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton1)
                    .addComponent(btnAtra))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void inpBuscarPacienteKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_inpBuscarPacienteKeyTyped
        DefaultListModel dlm = new DefaultListModel();
        String[] pacientesResultado = BusinessLogic.getPacientesContainst(this.inpBuscarPaciente.getText());
        for (String p : pacientesResultado) {
            dlm.addElement(p);
        }
        this.listPacientes.setModel(dlm);
    }//GEN-LAST:event_inpBuscarPacienteKeyTyped

    private void radioPositivoStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_radioPositivoStateChanged

    }//GEN-LAST:event_radioPositivoStateChanged

    private void radioPositivoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_radioPositivoActionPerformed
        this.inpIndicaciones.setVisible(true);
        this.lblIndicaciones.setVisible(true);
    }//GEN-LAST:event_radioPositivoActionPerformed

    private void radioNegativoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_radioNegativoActionPerformed
        this.inpIndicaciones.setVisible(false);
        this.lblIndicaciones.setVisible(false);
    }//GEN-LAST:event_radioNegativoActionPerformed

    private void radioMedicoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_radioMedicoActionPerformed
        this.drpdwnMedico.setVisible(true);
        this.inpValorado.setVisible(false);

        String labels[] = BusinessLogic.getMedicos();
        final DefaultComboBoxModel model = new DefaultComboBoxModel(labels);
        this.drpdwnMedico.setModel(model);
    }//GEN-LAST:event_radioMedicoActionPerformed

    private void radioMedico1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_radioMedico1ActionPerformed
        this.drpdwnMedico.setVisible(false);
        this.inpValorado.setVisible(true);
    }//GEN-LAST:event_radioMedico1ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        try {
            String paciente = this.listPacientes.getSelectedValue();
            if (!paciente.equals(null)) {
                int idPaciente = Integer.valueOf(paciente.trim().split("\t")[0]);
                if (this.radioMedico.isSelected()) {
                    int idMedico = Integer.valueOf(String.valueOf(this.drpdwnMedico.getSelectedItem()).trim().split("\t")[0]);
                    String indicaciones = Validator.getText(this.inpIndicaciones.getText(), "Indicaciones");
                    BusinessLogic.registrarResultadoPorMedico(idMedico, idPaciente, indicaciones, this.radioPositivo.isSelected());
                } else {
                    String valorador = Validator.getText(this.inpValorado.getText(), "Valorador de examen");
                    BusinessLogic.registrarResultadoPorOtro(valorador, idPaciente, this.inpIndicaciones.getText(), this.radioPositivo.isSelected());
                }
                JOptionPane.showMessageDialog(null, "¡Resultados agregados con éxito!");
            } else {
                JOptionPane.showMessageDialog(null, "Seleccione un paciente para agregar valoración");
            }
        } catch (Error err) {
            JOptionPane.showMessageDialog(null, err.getMessage());
        }
    }//GEN-LAST:event_jButton1ActionPerformed

    private void btnAtraActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAtraActionPerformed
        new MainWindow().setVisible(true);
        this.dispose();
    }//GEN-LAST:event_btnAtraActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAtra;
    private javax.swing.ButtonGroup buttonGroupResultado;
    private javax.swing.ButtonGroup buttonGroupValorador;
    private javax.swing.JComboBox<String> drpdwnMedico;
    private javax.swing.JTextField inpBuscarPaciente;
    private javax.swing.JTextArea inpIndicaciones;
    private javax.swing.JTextField inpValorado;
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JLabel lblIndicaciones;
    private javax.swing.JLabel lblTitle;
    private javax.swing.JList<String> listPacientes;
    private javax.swing.JRadioButton radioMedico;
    private javax.swing.JRadioButton radioMedico1;
    private javax.swing.JRadioButton radioNegativo;
    private javax.swing.JRadioButton radioPositivo;
    // End of variables declaration//GEN-END:variables
}
